using Nemerle.IO;

module M {
  public Main () : void {
    printf ("Testing the assertions...\n");
    
    mutable i <- 10;
    
    try
      assert (i == 10)    
    catch { _ : AssertionException => 
      printf ("Assertion number 1 failed\n") };

    i <- 20;

    try
      assert (i == 20)
    catch { _ : AssertionException => 
      printf ("Assertion number 2 failed\n") };

    try
      assert (i == 19) 
    catch { 
      | _ : AssertionException => 
        printf ("Assertion number 3 failed\n") 
      | _ : System.Exception =>
        printf ("Got System.Exception (wrong!)\n") 
    };
    
    try
      assert (i == 19) 
    catch { 
      | _ : System.Exception =>
        printf ("Got System.Exception (ok!)\n") 
      | _ : AssertionException => 
        printf ("Assertion number 3 failed (wrong!)\n") 
    };
    
  }
}

/*
BEGIN-OUTPUT
Testing the assertions...
Assertion number 3 failed
Got System.Exception (ok!)
END-OUTPUT
*/
